<script lang="ts">
// 声明额外的选项
export default {
  name: "Edit"
};
</script>
<script setup lang="ts">
import { inject, onMounted, reactive, ref, Uploadfile, UploadImg, Editor, useRenderIcon, ElMessage, ElMessageBox, Upload, Close, http, getGroupUrl, RegularVerification, verification } from "@/utils/importUsed"
// 接口列表实例
let UrlList = reactive(null)
// 获取当前板块接口列表
onMounted(async () => {
  UrlList = await getGroupUrl(["prizeSet"]);

})
const props = defineProps<{
  editVisible: {
    type: Boolean;
    default: false;
  };
  width: {
    type: Number;
    default: 50;
  };
  formData: {
    id: any;
    type: any;
    default: {};
  };
}>();
// 表单数据
const UpdateForm: any = ref({
  id: null, //ID
  title: "", //数据库名称
  ipAddress: "", //IP地址
  port: null, //端口
  userId: "", //用户名
  password: "", //密码
  databaseName: "", //数据库名

});

// 表单实例
const ruleFormRef = ref()

// 选项卡参数(默认值为列表某项的id)
const activeId = ref('1')
// 提交函数
const submit = async (formEl) => {
  // 表单校验拦截
  if (!formEl) return
  await formEl.validate(async (valid, fields) => {
    if (valid) {
      //表单校验成功回调
      console.log('submit!')

      // 需动态生成接口
      const { status, msg }: any = await http.Request({
        method: UrlList.prizeSet.priupdatePriDatabaseSet.method,
        url: UrlList.prizeSet.priupdatePriDatabaseSet.url,
        params: UpdateForm.value
      });
      if (status === 1) {
        //业务成功回调
        ElMessage({
          message: "修改成功",
          type: "success"
        });
        UpdateForm.value = {
          id: null, //ID
          title: "", //数据库名称
          ipAddress: "", //IP地址
          port: null, //端口
          userId: "", //用户名
          password: "", //密码
          databaseName: "", //数据库名

        };
        // 关闭修改弹窗;
        closeUpdatePriDatabaseSetVisible();
      } else {
        //业务失败回调
        ElMessageBox.alert(msg, "提示", {
          confirmButtonText: "关闭",
          type: "warning"
        });
      }
    } else {
      //表单校验失败回调
      ElMessage({
        message: "请输入完整信息",
        type: "error"
      });
    }
  })
};




// 表单校验规则
const rules = reactive({
  ipAddress: [
    { required: true, message: '请输入IP地址', trigger: 'blur' },
  ],
  port: [
    { required: true, message: '请输入端口', trigger: 'blur' },
  ],
  userId: [
    { required: true, message: '请输入用户名', trigger: 'blur' },
  ],
  password: [
    { required: true, message: '请输入密码', trigger: 'blur' },
  ],

})
// 关闭弹窗回调函数
const closeFn: any = inject('closeEditUpdatePriDatabaseSetVisible');
const openVisible = async () => {
  //通过ID获取表格数据
  const { status, data }: any = await http.Request({ method: UrlList.prizeSet.prigetPriDatabaseSetQuery.method, url: UrlList.prizeSet.prigetPriDatabaseSetQuery.url, params: { id: props.formData.id } });
  if (status === 1) {
    UpdateForm.value = data;

  }
};
// 关闭弹窗回调函数
const closeUpdatePriDatabaseSetVisible = () => {
  UpdateForm.value = {
    id: null, //ID
    title: "", //数据库名称
    ipAddress: "", //IP地址
    port: null, //端口
    userId: "", //用户名
    password: "", //密码
    databaseName: "", //数据库名

  };
  closeFn();
};

// 弹窗是否全屏
const isFullscreen = ref(false)
</script>

<template lang="pug">
.main
  el-dialog(v-model='props.editVisible' draggable width="50%" :fullscreen="isFullscreen" title="修改" @close="closeUpdatePriDatabaseSetVisible" @open="openVisible")
    el-form(:model='UpdateForm' label-position="right" ref="ruleFormRef" :rules="rules" label-width="100px")
      el-form-item(label='ID' prop="id")
        el-input-number(v-model='UpdateForm.id' :min="1" :max="100000"
          placeholder="请输入ID")
      el-form-item(label='数据库名称' prop="title")
        el-input(v-model='UpdateForm.title' autocomplete='off'
          placeholder="请输入数据库名称")
      el-form-item(label='IP地址' prop="ipAddress")
        el-input(v-model='UpdateForm.ipAddress' autocomplete='off'
          placeholder="请输入IP地址")
      el-form-item(label='端口' prop="port")
        el-input-number(v-model='UpdateForm.port' :min="0" :max="100000"
          placeholder="请输入端口")
      el-form-item(label='用户名' prop="userId")
        el-input(v-model='UpdateForm.userId' autocomplete='off'
          placeholder="请输入用户名")
      el-form-item(label='密码' prop="password")
        el-input(v-model='UpdateForm.password' autocomplete='off'
          placeholder="请输入密码")
      el-form-item(label='数据库名' prop="databaseName")
        el-input(v-model='UpdateForm.databaseName' autocomplete='off'
          placeholder="请输入数据库名")

    .flex.justify-end
      el-button(
        :icon="useRenderIcon(Close)",
        :loading="loading",
        @click="closeUpdatePriDatabaseSetVisible()"
      ) 关闭
      el-button(
        type="primary",
        :icon="useRenderIcon(Upload)",
        @click="submit(ruleFormRef)"
      ) 确认提交
</template>

<style scoped lang="scss">
:deep(.el-dropdown-menu__item i) {
  margin: 0;
}

:deep(.el-form-item__label) {
  font-weight: 700;
}

:deep(.el-pagination) {
  flex-flow: wrap;
}

:deep(.is-draggable) {
  max-height: 80vh;
  overflow: auto;
}

:deep(.el-dialog__header) {
  position: sticky;
  top: 0;
  z-index: 2;
  background: #fff;
}

.collapsedom {
  padding: 0 20px;
  background-color: #fff;
}

.ovh-x {
  height: 40vh;
  overflow-y: auto;
}

:deep(.el-descriptions__header) {
  margin: 16px 0 !important;
}

.el-select {
  width: 100%;
}
</style>
